/*
 Navicat Premium Data Transfer

 Source Server         : mogc
 Source Server Type    : SQLite
 Source Server Version : 3030001
 Source Schema         : main

 Target Server Type    : SQLite
 Target Server Version : 3030001
 File Encoding         : 65001

 Date: 07/05/2022 09:39:47
*/

PRAGMA foreign_keys = false;

-- ----------------------------
-- Table structure for DebugOrders
-- ----------------------------
DROP TABLE IF EXISTS "DebugOrders";
CREATE TABLE "DebugOrders" (
  "OrderID" TEXT(32) NOT NULL,
  "DEType" TEXT(8) NOT NULL,
  "DEValue" REAL NOT NULL,
  "Mode" INTEGER NOT NULL,
  "CreateTime" DATETIME DEFAULT ( datetime( 'now', 'localtime' ) ),
  PRIMARY KEY ("OrderID")
);

-- ----------------------------
-- Table structure for DebugSN
-- ----------------------------
DROP TABLE IF EXISTS "DebugSN";
CREATE TABLE "DebugSN" (
  "OrderID" TEXT(32) NOT NULL,
  "SN" TEXT(32) NOT NULL,
  "Line" TEXT(8) NOT NULL,
  "TestTime" DATETIME NOT NULL,
  "ElapsedTime" INTEGER NOT NULL,
  "TestResult" INTEGER NOT NULL,
  "DEAvgValue" REAL NOT NULL,
  "DEValue" REAL NOT NULL,
  "Outcome" TEXT NOT NULL,
  PRIMARY KEY ("SN")
);

PRAGMA foreign_keys = true;
