// PageStatistics.cpp : ʵļ
//

#include "stdafx.h"
#include "OGCAssistTool.h"
#include "PageStatistics.h"


// CPageStatistics Ի

IMPLEMENT_DYNAMIC(CPageStatistics, CDialogEx)

CPageStatistics::CPageStatistics(CWnd* pParent /*=NULL*/)
	: CDialogEx(CPageStatistics::IDD, pParent)
{

}

CPageStatistics::~CPageStatistics()
{
}

void CPageStatistics::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_ctrlList);
	DDX_Control(pDX, IDC_DATETIMEPICKER1, m_dtStartTime);
	DDX_Control(pDX, IDC_DATETIMEPICKER2, m_dtEndTime);
	DDX_Control(pDX, COMBO_ORDER, m_ctrlCombobox);
}


BEGIN_MESSAGE_MAP(CPageStatistics, CDialogEx)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(CHECK_BATCH_NUM, &CPageStatistics::OnBnClickedBatchNum)
	ON_BN_CLICKED(BTN_QUERY, &CPageStatistics::OnBnClickedQuery)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST1, &CPageStatistics::OnNMCustomdrawList1)
END_MESSAGE_MAP()


// CDlgDebug Ϣ

BOOL CPageStatistics::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  ڴӶĳʼ
	SetBackgroundColor(RGB(200,200,200));

	m_dtStartTime.SetFormat(_T("MM/dd HH:mm"));
	m_dtEndTime.SetFormat(_T("MM/dd HH:mm"));
	// ÿʼʱΪǰһ;
	CTime tm1 = CTime::GetCurrentTime();
	CTimeSpan tsp = CTimeSpan(3,0,0,0);
	tm1 -= tsp;
	m_dtStartTime.SetTime(&tm1);

	m_ctrlList.SetListFont(_T(""), 11, TRUE);
	m_ctrlList.SetHeadings(
		_T("ʱ,190"),
		_T("κ,120"),
		_T("ģʽ,80"),
		_T("SN,90"),
		_T("ɹ,90"),
		_T("ɹ,90"),
		_T("ƽʱ,120"),
		_T("ܺʱ,90"),
		_T("׼Eֵ,90"),
		NULL
		);	

	((CButton*)GetDlgItem(CHECK_TEST_TIME))->SetCheck(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

HBRUSH CPageStatistics::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  ڴ˸ DC κ
	switch ( pWnd->GetDlgCtrlID() ) 
	{
	case CHECK_TEST_TIME:
	case CHECK_TEST_RESULT:
	case CHECK_SN:
	case CHECK_BATCH_NUM:
		{
#if 1 // ͸ؼ;
			pDC->SetBkMode(TRANSPARENT);

			CRect rc;
			pWnd->GetWindowRect(&rc);
			ScreenToClient(&rc);

			CDC* dc = GetDC();
			pDC->BitBlt(0,0,rc.Width(),rc.Height(),dc,rc.left,rc.top,SRCCOPY);  //ѸڱͼƬȻť

			ReleaseDC(dc);
			hbr = (HBRUSH) ::GetStockObject(NULL_BRUSH);
#endif
		}
		break;
	default:
		break; 
	}
	// TODO:  ĬϵĲ軭ʣ򷵻һ
	return hbr;
}

void CPageStatistics::OnBnClickedBatchNum()
{
	// TODO: ڴӿؼ֪ͨ
	BOOL bCheck = ((CButton*)GetDlgItem(CHECK_BATCH_NUM))->GetCheck();
	if ( bCheck )
	{
		// ;
		std::vector<TB_ORDER> vtOrders;
		GLOBAL::g_db.QueryOrders(vtOrders);
		m_ctrlCombobox.ResetContent();
		for (std::vector<TB_ORDER>::iterator it = vtOrders.begin(); it != vtOrders.end(); it++ )
		{
			m_ctrlCombobox.AddString(CharEncoding::ASCII2UNICODE(it->strOrder.c_str()));
		}

		m_ctrlCombobox.SetCurSel(-1);
	}
}

void CPageStatistics::OnBnClickedQuery()
{
	// TODO: ڴӿؼ֪ͨ
	BOOL bCheckDate = ((CButton*)GetDlgItem(CHECK_TEST_TIME))->GetCheck();
	BOOL bCheckBatchNum = ((CButton*)GetDlgItem(CHECK_BATCH_NUM))->GetCheck();

	if ( !(bCheckDate || bCheckBatchNum ) )
	{
		MessageBox(_T("빴ѡĳһܲѯݣ"), _T("ʾ"), MB_ICONWARNING);
		return;
	}

	std::string strWhere;
	if ( bCheckDate )
	{
		CTime tStart;
		CTime tEnd;
		m_dtStartTime.GetTime(tStart);
		m_dtEndTime.GetTime(tEnd);

		strWhere.append("CreateTime >= '");
		strWhere.append(CharEncoding::UNICODE2ASCII((LPWCH)tStart.Format(_T("%Y-%m-%d %H:%M:%S")).GetString()));
		strWhere.append("' and CreateTime <='");
		strWhere.append(CharEncoding::UNICODE2ASCII((LPWCH)tEnd.Format(_T("%Y-%m-%d %H:%M:%S")).GetString()));
		strWhere.append("'");
	}

	if ( bCheckBatchNum )
	{
		CString strOrder;
		GetDlgItemText(COMBO_ORDER, strOrder);
		if ( strWhere.size() )
			strWhere.append(" and DebugSN.OrderID='");
		else
			strWhere.append(" DebugSN.OrderID='");
		strWhere.append(CharEncoding::UNICODE2ASCII((LPWCH)strOrder.GetString()));
		strWhere.append("'");
	}

	std::vector<TB_STATIS> vtStatis;
	if ( GLOBAL::g_db.StatisticalQuery(vtStatis, strWhere) != -1 )
	{
		UpdateList(vtStatis);
	}
}

void CPageStatistics::UpdateList(std::vector<TB_STATIS> &vtStatis)
{
	int nIndex = 0;
	CString strValue;
	m_ctrlList.RemoveAll();
	m_ctrlList.m_AryList.SetSize(vtStatis.size(), 1);
	for (std::vector<TB_STATIS>::iterator it = vtStatis.begin(); it != vtStatis.end(); it++)
	{
		CStringArray arryString;
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strCreateTime.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strOrderID.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strMode.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strTotalCount.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strPassCount.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strPassRate.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strAvgElapsed.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strTotalElapsed.c_str()));
		arryString.Add(CharEncoding::ASCII2UNICODE(it->strDeltaEValue.c_str()));

		//arryString.Add(strValue);
		m_ctrlList.m_AryList.ElementAt(nIndex++).Copy(arryString);
	}
	//m_ctrlList.m_AryList.SetSize(vtRGB.size(), 1);
	m_ctrlList.SetItemCountEx(vtStatis.size());
}

void CPageStatistics::OnNMCustomdrawList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>( pNMHDR );
	*pResult = 0;
	if ( CDDS_PREPAINT == pLVCD->nmcd.dwDrawStage )
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
	}
	else if ( CDDS_ITEMPREPAINT == pLVCD->nmcd.dwDrawStage )
	{
		if ( pLVCD->nmcd.dwItemSpec % 2 )
			pLVCD->clrTextBk = RGB(204,204,204);
		else 
			pLVCD->clrTextBk = RGB(190,190,190);
		*pResult = CDRF_DODEFAULT;
	}
}
